<template>
  <div id="teacher_lecture_live_wrapper" class="bt-container" style="height: 100%; width: 1000px">
    <span style="display:inline-block; width: 200px; text-align:center; position: relative">
      <video controls width="100%" id="myVideo"/>
      <span> myVideo </span>
    </span>

    <span style="display:inline-block; width: 200px; text-align:center; position: relative">
      <video controls width="100%" id="yourVideo"/>
      <span> yourVideo </span>
    </span>

    <el-dialog
      :visible.sync="videoSelectorVisible">
      비디오 장치를 선택하세요.
      <el-table
        :data="videoList"
        highlight-current-row
        @current-change="selectVideo">
        <el-table-column property="label" label="장치 이름"></el-table-column>
      </el-table>
    </el-dialog>
    <el-dialog
      :visible.sync="audioSelectorVisible">
      오디오 장치를 선택하세요.
      <el-table
        :data="audioList"
        highlight-current-row
        @current-change="selectAudio">
        <el-table-column property="label" label="장치 이름"></el-table-column>
      </el-table>
    </el-dialog>  
  </div>
</template>

<script>
import utils from '../../utils';

export default {
  name: 'SGroupRoom',
  async created() {
    const vm = this;

    const devices = await navigator.mediaDevices.enumerateDevices();
    devices.forEach((device) => {
      if (device.kind === 'videoinput') {
        vm.hasVideo = true;
        console.log('비디오 장치 감지됨');
      }
      if (device.kind === 'audioinput') {
        vm.hasAudio = true;
        console.log('오디오 장치 감지됨');
      }
    });
    vm.hasVideo = false;
    vm.hasAudio = true;

    // vm.localStream = await navigator.mediaDevices.getUserMedia({
    //   audio: vm.hasAudio ? { echoCancellation: true } : false,
    //   video: vm.hasVideo ? { frameRate: { ideal: 5, max: 5 }, width: 320, height: 200 } : false,
    // });

    vm.localStream = await navigator.mediaDevices.getUserMedia({
      audio: true,
      video: false,
    });

    const myVideo = vm.$el.querySelector('video[id*="myVideo"]');
    myVideo.srcObject = vm.localStream;
    myVideo.autoplay = true;

    // 입장 사실 서버에 알림
    vm.$socket.emit('DISCUSSION' , JSON.stringify({
      discussion_room_id: vm.discussionRoomId,
      from_email_id: utils.getEmailFromJwt(),
      from_name: utils.getNameFromJwt(),
    }));

    vm.sockets.subscribe('DISCUSSION', async (evt) => {
      const signal = JSON.parse(evt);

      if (signal.call_me || signal.offer) {
        console.log( 'on call_me or offer (pc created)');
        vm.pc = new RTCPeerConnection(vm.configuration);
        
        console.log('vm.pc.iceConnectionState = ', vm.pc.iceConnectionState);

        if ( vm.hasAudio || vm.hasVideo ) {
          vm.localStream.getTracks().forEach(track => {
            vm.pc.addTrack(track, vm.localStream);
          });       
        }

        // Listen for local ICE candidates on the local RTCPeerConnection
        vm.pc.addEventListener('icecandidate', event => {
          if (event.candidate) {
            vm.$socket.emit('DISCUSSION', JSON.stringify({
              candidate: event.candidate,
              to_socket_id: signal.from_socket_id,
              from_email_id: utils.getEmailFromJwt(),
              from_name: utils.getNameFromJwt(),
            }));
            console.log( 'emit icecandidate');
          }
        });

        vm.pc.addEventListener('connectionstatechange', event => {
          if (vm.pc.connectionState === 'connected') {
            console.log( 'peer connected!');
          }
          if (vm.pc.connectionState === 'disconnected') {
            console.log( 'peer disconnected!');
          }
        });

        vm.pc.addEventListener('icegatheringstatechange', event => {
          console.log('vm.pc.iceGatheringState = ', vm.pc.iceGatheringState);
        })

        vm.pc.addEventListener('iceconnectionstatechange', event => {
          console.log('vm.pc.iceConnectionState = ', vm.pc.iceConnectionState);
        })

        vm.pc.addEventListener('track', async (event) => {
          console.log( 'on track ☆');
          remoteStream.addTrack(event.track, remoteStream);
         
          let targetVideo = vm.$el.querySelector('#yourVideo');
          targetVideo.srcObject = remoteStream;
          targetVideo.play();
        });

        const remoteStream = new MediaStream();
      }

      if (signal.call_me) {
        console.log( 'on call_me');
        const offer = await vm.pc.createOffer();
        await vm.pc.setLocalDescription(offer);
        
        vm.$socket.emit('DISCUSSION' , JSON.stringify({
          to_socket_id: signal.from_socket_id,
          from_email_id: utils.getEmailFromJwt(),
          from_name: utils.getNameFromJwt(),
          offer,
        }));
        console.log( 'emit offer');
      }

      if (signal.offer) {
        console.log( 'on offer');
        vm.pc.setRemoteDescription(new RTCSessionDescription(signal.offer));
        const answer = await vm.pc.createAnswer();
        vm.$socket.emit('DISCUSSION', JSON.stringify({
          to_socket_id: signal.from_socket_id,
          from_email_id: utils.getEmailFromJwt(),
          from_name: utils.getNameFromJwt(),
          answer,
        }));
        console.log( 'emit answer');
        await vm.pc.setLocalDescription(answer);
      }
      if (signal.answer) {
        console.log( 'on answer');
        console.log('signal.from_socket_id = ', signal.from_socket_id);
        const remoteDesc = new RTCSessionDescription(signal.answer);
        await vm.pc.setRemoteDescription(remoteDesc);
      }
      if (signal.candidate) {
        try {
          await vm.pc.addIceCandidate(signal.candidate);
          console.log( 'add icecandidate');
        } catch (e) {
          console.error( 'Error adding received ice candidate', e);
        }
      }
    })
  },
  data() {
    return {
      // webRTC ***********************
      pc: undefined,
      configuration: {
        iceServers: [
          {
            urls: 'turn:wiseswot.com:3478',
            username: 'test',
            credential: 'test123',
          },
        ],
        // iceTransportPolicy: 'relay',
      },
      localStream: undefined,
      hasAudio: false,
      hasVideo: false,
      videoSelectorVisible: false,
      audioSelectorVisible: false,
      audioList: [{
        deviceId: null,
        label: '사용 안함',
      }],
      videoList: [{
        deviceId: null,
        label: '사용 안함',
      }],
    };
  },
  computed: {
    discussionRoomId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.roomId, 10);
    },
  },
  async beforeDestroy() {
    console.log('@beforeDestroy');
    const vm = this;
    
    if (vm.localStream) {
      vm.localStream.getTracks().forEach((track) => { // 비디오, 오디오 수집 중지
        track.stop();
      })
    }

    vm.pc.close();
  },
  methods: {
    async selectVideo(arg) {
      const vm = this;
      vm.videoDeviceId = arg.deviceId;
      vm.videoSelectorVisible = false;
      vm.audioSelectorVisible = true;
    },
    async selectAudio(arg) {
      const vm = this;
      vm.audioDeviceId = arg.deviceId;
      vm.audioSelectorVisible = false;
      vm.webRTCConnect();
    },
  }
};
</script>         

<style>
  .el-row {
    margin-bottom: 30px;
    
  }
  .el-col {
    border-radius: 4px;
  }
  .bg-purple-dark {
    background: #99a9bf;
  }
  .bg-success{
    padding:5px 0;
    background: #b6f3d1;
    line-height:40px;
    font-weight: 900;
    font-size: 25px;
    color:#34ce16;
  }
  .bg-fail{
    padding:5px 0;
    background: #fa9090;
    line-height:40px;
    font-weight: 900;
    font-size: 25px;
    color:#e01818;
  }
  .bg-purple {
    padding:5px 0;
    background: #2525258a;
    text-align:center;
    line-height:40px;
    font-weight: 900;
    font-size: 25px;
    color:#ffffff;
  }
  .bg-purple-light {
    background: #e5e9f2;
  }
  .grid-content {
    border-radius: 4px;
    min-height: 46px;
  }
  .row-bg {
    padding: 5px 0;
    background-color: #ffffff00;
  }
</style>
</script>
